#!/usr/bin/perl
# Copyright: Binny V Abraham 2003-2004                                     #
# If you want to use this script, Leave this message here                  #
############################################################################
# Website: http://binnyva.tripod.com                                       #
# E-Mail : binnyva@rediffmail.com                                          #
# Get more Perl scripts from http://binnyva.tripod.com/code/perl           #
############################################################################
# Name : SeekAndExtract                                                    #
# Version : 1.00.B                                                         #
# For extracting content from HTML files from $search_string to $end_string#
# and save them as a txt file.                                             #
#                                                                          #
# From 1-10-2003 to 3-10-2003                                              #
############################################################################

# Take the directory to search in from the command line
if($ARGV[0])
 {
 $docroot = $ARGV[0];
 print "Search in @ARGV[0]\n";
 }
# If no command line, Exit
else 
 {
 print "Plese specify the directory...";
 exit 0;
 }

# Go to the directory in question
chdir($docroot);

# The Starting string
$search_string = "<body>";
# The Ending String
$end_string = "</body>";
# The Program takes all info from the starting string to the ending String

# Get a list of all matching files
my $list;
$list = `dir /b *.htm`;
# Store the list in an arry
my @LIST = split(/\s+/, $list);

print "----------------------------------------------------------\n";
print "Files to Process\n@LIST\n";
# print "Procedure: Extract all content from $search_string to $end_string\n";
print "----------------------------------------------------------\n";

foreach $file (@LIST) 
 {
 print "------------------------------------------\nProccessing $file\n";
 open (FILE, "$file") || die "Can't open $file: $!\n";
 @LINES=<FILE>;
 close(FILE);
 $SIZE=@LINES;

 $flag=0;
 $data = "";

 for ($i = 0; $i <= $SIZE; $i++)
  {
  $_=$LINES[$i];
  if (/.*$search_string.*/i&&!$flag)
   {
   $j=$i;
   print "Found Search Sting at line $i. Beginning Coping...\n"; 
   while(!$flag) 
    {
    $data .= $LINES[$j];   
    $j++;
    $_=$LINES[$j];
#     print "$j"; #DEBUG
    if(/.*$end_string.*/gi)
     {
     $flag=1;
     print "End String Encontered at line $j. Exiting...\n";
     }
    }
   }
  }
 if($flag)
  {
  # Remove all the html tags, multiple carrage-return, multiple spaces. Converts <br> to carrage-return
  $data =~ s/\n//gi;
  $data =~ s/<BR>/\n/gi;
  $data =~ s/<b> //g;
  $data =~ s/<.*>//g;
  $data =~ s/  //g;
  $data =~ s/\n\n\n//g;
  #print "\nExtracted data:\n$data\n";
  
  # To find the output file name
  $len = length($file);
  $dot_no = $len - 3;
  $res_file = $file;
  substr($res_file, $dot_no,$len-1,"txt");
  # Open and save data to output file
  open (OUTFILE,">$res_file") || die "Can't open file $res_file for editing because $!\n";
  print OUTFILE "$data";
  close (OUTFILE);
  print "\nThe content was extracted from file $file and stored in $res_file file.\n";
  }
 }

exit(0);